<!DOCTYPE html>
<html>

<head>
    <title>Lucky Dice Casino</title>
    <meta charset='utf-8'>
    <meta name='viewport' content='width=device-width, initial-scale=1'>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- class CSS để dùng trong bài -->
    <style>
        .picture-cover { 
            background-image: url("LuckyDiceImages/cover.jpg");
            min-height: 100px;
            margin: 5px;
        }
    </style>
</head>
<script>
    "use strict";
    $(document).ready(function(){
    //REGION 1
    const gREQUEST_READYSTATE_FINISH_RESPONSE_READY = 4;
    const gREQUEST_STATUS_OK = 200;
    //REGION 2
    $("#btn-dice").click(function(event){
        event.preventDefault();
        onBtnNemClick()
    })
    //REGION 3
    function onBtnNemClick(){
        "use strict";
        console.log("nút nem được ấn");
        var vUserObj = { //b1 khai báo biến lưu dữ liệu, thu thập dữ liệu
            userName: "",
            firstName: "",
            lastName: ""
        }
        getDataUserObj(vUserObj);
        var vIsCheck = validateUser(vUserObj) //b2 kiểm tra dữ liệu
        if(vIsCheck){
            callApiGetNewDice(vUserObj)//b3 gọi server lấy responseText 
            
        }
    }
    //REGION 4
    function getDataUserObj(paramUser){ //hàm thu thập dữ liệu
        paramUser.userName = $("#inp-user-name").val().trim();
        paramUser.firstName = $("#inp-first-name").val().trim();
        paramUser.lastName = $("#inp-last-name").val().trim();
    }
    function validateUser(paramUser){ //hàm kiểm tra dữ liệu
        if(paramUser.userName == ""){
            alert("Bạn chưa nhập username");
            return false;
        }
        if(paramUser.firstName == ""){
            alert("Bạn chưa nhập firstname");
            return false;
        }
        if(paramUser.lastName == ""){
            alert("Bạn chưa nhập lastname");
            return false;
        }
        return true;
    }
    function callApiGetNewDice(paramUser) { //hàm goi server lấy responseText
        "use strict";
        const vBaseUrl = "http://203.171.20.210:8080/devcamp-lucky-dice/";//base urlbaseUrk
        var vXmlHttpDice = new XMLHttpRequest();
        vXmlHttpDice.open("POST", vBaseUrl + "/dice", true);
        vXmlHttpDice.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
        vXmlHttpDice.send(JSON.stringify(paramUser));  //chuyển Json object sang string
        vXmlHttpDice.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READYSTATE_FINISH_RESPONSE_READY
                && this.status == gREQUEST_STATUS_OK) {  //nếu trạng thái của response ready và ok
                console.log(vXmlHttpDice.responseText);
                showDataDiceToConsole(vXmlHttpDice);
                showNotification(vXmlHttpDice);
                showVoucher(vXmlHttpDice);
            }
        }
    }
    //hàm hiển thị thông tin dice 
    function showDataDiceToConsole(paramXmlHttp){
        var vDiceObj = JSON.parse(paramXmlHttp.responseText);
        var vNewDice = vDiceObj.dice;
        console.log("%cDice: " + vNewDice, "color: green");
        var vImgDice = $("#img-dice");

        switch(vNewDice){
            case 1:
            vImgDice.attr("src", "LuckyDiceImages/1.png");
            break;
            case 2:
            vImgDice.attr("src", "LuckyDiceImages/2.png");
            break;
            case 3:
            vImgDice.attr("src", "LuckyDiceImages/3.png");
            break;
            case 4:
            vImgDice.attr("src", "LuckyDiceImages/4.png");
            break;
            case 5:
            vImgDice.attr("src", "LuckyDiceImages/5.png");
            break;
            default:
            vImgDice.attr("src", "LuckyDiceImages/6.png");
        }
    }
    //hàm hiển thị lời nhắn
    function showNotification(paramXmlHttp){
        var vDiceObj = JSON.parse(paramXmlHttp.responseText);
        var vNewDice = vDiceObj.dice;
        var vNotification = $("#p-notification-dice");
        if(vNewDice < 3){
            vNotification.html("Chúc bạn may mắn lần sau");
        }
        else{
            vNotification.html("Chúc mừng bạn hãy chơi tiếp lần nữa!!!");
        }
    }
    //hàm hiểm thị voucher
    function showVoucher(paramXmlHttp){
        var vDiceObj = JSON.parse(paramXmlHttp.responseText);
        var vNewVoucher = vDiceObj.voucher;
        var vVoucherId = $("#p-voucher-id");
        var vPrize = $("#p-voucher-percent");
        if(vNewVoucher != null){
            vVoucherId.html(vNewVoucher.maVoucher);
            vPrize.html(vNewVoucher.phanTramGiamGia + "%");
        }else{
            vVoucherId.html("");
            vPrize.html("");
        }
    }
    })
</script>
<body>
    <div class="container-fluid  picture-cover">
        
    </div>
    <div class="container ">
        <div class="row ">
            <div class="col-5 bg-white  ">
                <div class="row  form-group">
                    <div class="col-12"> <!-- Tại dòng 2.1.1.1 thêm một div column rộng 12 đơn vị -->
                        <h4>Nhập thông tin của bạn</h4>
                    </div>
                </div>
                <div class="row   form-group"> <!-- tại mỗi dòng 2.1.1.2 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  "> <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Username</label>
                    </div>
                    <div class="col-8  "> <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-user-name" class="form-control" type="text">
                    </div>
                </div>
                <div class="row   form-group"> <!-- tại mỗi dòng 2.1.1.3 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  ">  <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Firstname</label>
                    </div>
                    <div class="col-8  ">  <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-first-name" class="form-control" type="text">
                    </div>
                </div>
                <div class="row   form-group"><!-- tại mỗi dòng 2.1.1.4 thêm 2 div column có chiều rộng lần lượt là 4, 8 đơn vị -->
                    <div class="col-4  ">  <!-- chiều rộng 4 đơn vị (col-4) -->
                        <label>Lastname</label>
                    </div>
                    <div class="col-8  "> <!-- chiều rộng 8 đơn vị (col-8) -->
                        <input id="inp-last-name" class="form-control" type="text">
                    </div>
                </div>
            </div>
            <div class="col-4  text-center"> <!-- Tại cột 2.1.2 tạo 3 div class row, cột 2.1.2 có thuộc tính căn giữa -->
               <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <input id="btn-dice" class="btn btn-success button-width w-75" value="Ném" type="button">
                    </div>
               </div>
               <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị-->
                        <img id="img-dice" class="img-thumbnail" src="LuckyDiceImages/dice.png">
                    </div>
                </div>
                <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <p id="p-notification-dice">Chúc mừng</p>
                    </div>
                </div>
            </div>
            <div class="col-3  text-center"> <!-- Tại cột 2.1.3 tạo 2 div class row, cột 2.1.3 có thuộc tính căn giữa -->
                <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị -->
                        <p>Voucher</p>
                        <p id="p-voucher-id">No ID</p>
                        <p id="p-voucher-percent">0%</p>
                    </div>
               </div>
               <div class="row form-group">
                    <div class="col-12   "> <!-- trong mỗi row chứa 1 cột rộng 12 đơn vị-->
                        <img id="img-present" class="img-thumbnail" src="LuckyDiceImages/motobike.jpg">
                    </div>
                </div>
            </div>
        </div>
        <div class="row  text-center form-group"> <!-- Tại row 2.2 thêm một div column rộng 12 đơn vị  -->
            <div class="col-12">
                <button id="btn-dice-history" class="btn btn-info button-width w-25">Dice History</button>
                <button id="btn-voucher-history" class="btn btn-success button-width w-25">Voucher History</button>
                <button id="btn-present-history" class="btn btn-success button-width w-25">Present History</button>
            </div>
        </div>
        <div class="row "> <!-- Tại row 2.3 thêm một div column rộng 12 đơn vị  -->
            <div class="col-12">
                <table id="history-placeholder-table" class="table table-striped table-hover ">
                    <tr>
                        <th>Lượt</th>
                        <th>Dice</th>
                    </tr>
                    <tr>
                        <td>1</td>
                        <td>2</td>
                    </tr>
                    <tr>
                        <td>2</td>
                        <td>6</td>
                    </tr>
                    <tr>
                        <td>3</td>
                        <td>4</td>
                    </tr>
                    <tr>
                        <td>4</td>
                        <td>5</td>
                    </tr>
                    <tr>
                        <td>5</td>
                        <td>4</td>
                    </tr>
                </table>
            </div>
        </div>
    </div>
</body>

</html>